/*
g
CoinTest01.exe  xx [yy]

xx ́AvZBitʒuFO`RP
yy ́A[v̉񐔁Bȗ  PƂ݂ȂB
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
double		st_t,	ed_t,	st_t0;

#include "mt19937ar.c"

unsigned int p1=10,p2=20,p3=30,p4=40;
unsigned long init[4]={0x123, 0x456, 0x789, 0xabc}, length=4;

int	win60,win70,win75,win40,win30,win25;
int	lose60,lose70,lose75,lose40,lose30,lose25;

unsigned int	iMask= 0x1;

FILE	*in, *out;

char	FileName[32]= "Bit";
char	ch[8]= "xx.txt";

int main(int argc,char **argv ){

	{
		int	k;
		if( argc>=2 ){
			k=  atoi( argv[1] );
			if( k<0 || k>=32 ){
				printf("Program.exe  xx( 0to31 )\n");
				return( -1 );
			}
		}
		else{
			printf("Program.exe  xx( 0to31 )\n");
			return( -1 );
		}
		iMask <<= k;

		if( k<10 )		ch[0]= '0';
		else if( k<20 )	ch[0]= '1';
		else if( k<30 )	ch[0]= '2';
		else			ch[0]= '3';
		ch[1]= '0' + ( k%10 );

		strcat( FileName, ch );
	}

	int	iLoop= 1;
	{
		if( argc>=3 ){
			iLoop=  atoi( argv[2] );
			if( iLoop<1 )	return( -1 );
		}
	}

	out = fopen( FileName , "at");
	fclose( out );
	fflush( out );

	//	()
	{
		p1 += time( NULL );
		p2 += clock();
		init_by_array(init, length);

		init[0]= p1+=  genrand_int32();
		init[1]= p2+=  genrand_int32();
		init[2]= p3+=  genrand_int32();
		init[3]= p4+=  genrand_int32();
		init_by_array(init, length);
	}

	for( ;iLoop>0;iLoop--){
		printf("%d\n",iLoop);

		{
			init[0]= p1+=  genrand_int32() + clock();
			init[1]= p2+=  genrand_int32() + clock();
			init[2]= p3+=  genrand_int32() + clock();
			init[3]= p4+=  genrand_int32() + clock();
			init_by_array(init, length);
			printf("%x %x %x %x\n",p1,p2,p3,p4);
		}

		st_t0= (double)clock();

		win70= win60= win40= win30= win75= win25= 0;
		lose70= lose60= lose40= lose30= lose75= lose25= 0;

#define  kkLoop 1000
#define  kLoop 10000000

		int		ia,	ib;
		int		i,k,kk;

		st_t= (double)clock();
		for( kk= kkLoop;kk>0;kk-- ){
			for( k= kLoop;k>0;k-- ){
				ia= 0;
				for( i=100;i>0;i-- ){
					if( ( genrand_int32() & iMask ) != 0 ) ia++;
				}
				ib= ( genrand_int32() & iMask );
				if( ia >= 60 ){
					if( ib != 0 )	win60++;
					else			lose60++;

					if( ia >= 70 ){
						if( ib != 0 )	win70++;
						else			lose70++;

						if( ia >= 75 ){
							if( ib != 0 )	win75++;
							else			lose75++;
						}
					}
				}else{
					if( ia <= 40 ){
						if( ib != 0 )	lose40++;
						else			win40++;

						if( ia <= 30 ){
							if( ib != 0 )	lose30++;
							else			win30++;

							if( ia <= 25 ){
								if( ib != 0 )	lose25++;
								else			win25++;
							}
						}
					}
				}

			}	// k
		}	//	kk
		ed_t= (double)clock();
		printf( "kLoop=%d\tkkLoop=%d\n",kLoop, kkLoop );
		printf( "win60=\t%d\tlose60=\t%d\t",win60,lose60 );
		printf( "win70=\t%d\tlose70=\t%d\t",win70,lose70 );
		printf( "win75=\t%d\tlose75=\t%d\t",win75,lose75 );

		printf( "win40=\t%d\tlose40=\t%d\t",win40,lose40 );
		printf( "win30=\t%d\tlose30=\t%d\t",win30,lose30 );
		printf( "win25=\t%d\tlose25=\t%d\n",win25,lose25 );

		printf("\n %6.2f sec\n", (ed_t-st_t)/(double)CLK_TCK );

		//		printf("%d\t%d\t%d\t%d\n",p1,p2,p3,p4 );
		printf("%x\n",p1);

		out = fopen( FileName , "at");

		fprintf( out,"kLoop= %d\tkkLoop= %d\n",kLoop, kkLoop );
		fprintf( out,"win60=\t%d\tlose60=\t%d\t",win60,lose60 );
		fprintf( out,"win70=\t%d\tlose70=\t%d\t",win70,lose70 );
		fprintf( out,"win75=\t%d\tlose75=\t%d\t",win75,lose75 );

		fprintf( out,"win40=\t%d\tlose40=\t%d\t",win40,lose40 );
		fprintf( out,"win30=\t%d\tlose30=\t%d\t",win30,lose30 );
		fprintf( out,"win25=\t%d\tlose25=\t%d\t",win25,lose25 );

		fprintf( out, "%x\t%x\t%x\t%x\t",p1,p2,p3,p4 );
//		fprintf( out, "%x\t",p1 );

		fprintf(out,"\t %6.2f sec\n", (ed_t-st_t)/(double)CLK_TCK );

		fclose( out );
	}	// iLoop;

	return( 0 );
}  /* end of main */
