/************************************************
0-1 ̎̕]
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
time_t		st_t,ed_t;

#include "127-G46s.h"

unsigned	int	p1; //,p2,p3,p4;

int main(int argc,char **argv ){

	int		i,j,k;

	const	int		jloop=100; //00; //00;
	const	int		iloop=1000000;
	const	int		kloop=1;

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drand\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					dTemp = MT_drand() + MT_drand() + MT_drand() + MT_drand()
					+ MT_drand() + MT_drand() + MT_drand() + MT_drand()
					+ MT_drand() + MT_drand() + MT_drand() + MT_drand() -6.0;
					sum  +=  dTemp;
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drandp\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					dTemp = MT_drandp() + MT_drandp() + MT_drandp() + MT_drandp()
					+ MT_drandp() + MT_drandp() + MT_drandp() + MT_drandp()
					+ MT_drandp() + MT_drandp() + MT_drandp() + MT_drandp() -6.0;
					sum += dTemp;
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drand_52\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					dTemp = MT_drand_52() + MT_drand_52() + MT_drand_52() + MT_drand_52()
					+ MT_drand_52() + MT_drand_52() + MT_drand_52() + MT_drand_52()
					+ MT_drand_52() + MT_drand_52() + MT_drand_52() + MT_drand_52() -6.0;
					sum += dTemp;
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drandp_52\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					dTemp = MT_drandp_52() + MT_drandp_52() + MT_drandp_52() + MT_drandp_52()
					+ MT_drandp_52() + MT_drandp_52() + MT_drandp_52() + MT_drandp_52()
					+ MT_drandp_52() + MT_drandp_52() + MT_drandp_52() + MT_drandp_52() -6.0;
					sum += dTemp;
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

	} // for( k )

	return(0);

}  /* end of main */

