/************************************************
Kz̕]

308 ƌ݊
308  ́Adouble						27.42 sec	274.45 sec
309  ́Along x2 Ōオl	26.98 sec	268.63 sec  2.12%

************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
time_t		tt;
double		st_t,ed_t;

#include "mt19937ar.c"
//#include "127-G46q.c"

char	OutFile[]= "ndist309G-mt.txt";
//char	OutFile[]= "127-G45q.c.txt";

inline double	MT_nsdMt( void );

double		MT_nsdMTsub( void );
static		int		nsd_fg1=0;

int main(int argc,char **argv ){

	long	in0[64], in1[64];

	int		i,j,k;

	double	dMax;
	double	dMin;

	double	dn[64];

	const	int		jloop=500; //00; //00;
	const	int		iloop=100000000;
	const	int		kloop=20;

	FILE	*out;

	out = fopen( OutFile , "at");
	fclose( out );

unsigned long	init_key[4];
int				length= 4;
unsigned int	p1, p2, p3, p4;

	p1= p2= p3= p4= 10;
	{
//		time_t	tt;
		p1 += time( NULL );
		init_by_array(init_key, length);

		init_key[0]= p1+=  genrand_int32();
		init_key[1]= p2+=  genrand_int32();
		init_key[2]= p3+=  genrand_int32();
		init_key[3]= p4+=  genrand_int32();
		init_by_array(init_key, length);
	}

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		for( i=0;i<64;i++) dn[i]=0.0;
		for( i=0;i<64;i++) in0[i]=0;
		for( i=0;i<64;i++) in1[i]=0;

		dMax= dMin= 0.0;

		//	()
		{
			init_key[0]= p1+=  genrand_int32() + clock();
			init_key[1]= p2+=  genrand_int32() + clock();
			init_key[2]= p3+=  genrand_int32() + clock();
			init_key[3]= p4+=  genrand_int32() + clock();
			init_by_array(init_key, length);
			printf("%x %x %x %x\n",p1,p2,p3,p4);
		}

		st_t= (double)clock();

		for( j=0;j<jloop;j++ ){
			//			printf("%d  ",j);
			for( i=0;i<iloop;i++ ){
				double	dTemp;
				int		iTemp;

				if( ( dTemp= MT_nsdMt() ) > dMax )	dMax= dTemp;	// MT_nsdMTsub.o
				else if ( dTemp < dMin )			dMin= dTemp;

				if( ++in0[ iTemp= (int)( dTemp + 20.0 ) ] >= 100000000 ){
					in1[ iTemp ]++;
					in0[ iTemp ]= 0;
				}
			}
		}

		for( i=0;i<64;i++ ) dn[i]= (double)in0[i] + (double)in1[i]*1.0e8;

		ed_t= (double)clock();

		if (( out = fopen( OutFile , "at")) == NULL){
			printf(" I can not open an input file.\n");
			exit(0);
		}

		printf("\n%x %x %x %x\n",(unsigned)init_key[0], (unsigned)init_key[1], (unsigned)init_key[2], (unsigned)init_key[3] );
		fprintf(out,"\n%x %x %x %x\n",(unsigned)init_key[0], (unsigned)init_key[1], (unsigned)init_key[2], (unsigned)init_key[3] );

		printf("\n %6.2f sec", (ed_t-st_t)/(double)CLK_TCK );
		fprintf(out,"\n %6.2f sec", (ed_t-st_t)/(double)CLK_TCK );

		//		printf("\n jloop=,\tiloop=\n");
		fprintf(out,"\n jloop=,\tiloop=\n");

		//		printf("\n%d",jloop );
		//		printf("\n%d",iloop );
		fprintf(out,"\n%d",jloop );
		fprintf(out,"\n%d",iloop );

		for( i=9;i<31;i++){
			printf("%15.0lf\n",dn[i]);
			fprintf(out,"%15.0lf\n",dn[i]);
		}

		printf("%12.8f\n%12.8f\n",dMax, dMin);
		fprintf( out, "%12.8f\n%12.8f\n",dMax, dMin);

		fflush( out );
		fclose( out );

	} // for( k )
	return( 0 );
}  /* end of main */

//---------

double	u1[3];

inline double	MT_nsdMt( void ){		// better
	//static		int		nsd_fg1=0;  // Ă̐͏ȂB֐̊OɏoāAł悤ɂׂH
	//		const	double	int2dbl2M2=	(2.0/UINT_MAX); // [0..1]

	if( nsd_fg1 ){
		return( u1[--nsd_fg1] );
	}else{
		nsd_fg1= 3; // ture
		return( MT_nsdMTsub() );
	}
}



