/************************************************
Kz̕]

308 ƌ݊
308  ́Adouble						27.42 sec	274.45 sec
309  ́Along x2 Ōオl	26.98 sec	268.63 sec  2.12%

************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
double		st_t,ed_t;

//#include "mt19937ar.c"
#include "127-G46s.h"

unsigned int	p1; //,p2,p3,p4;

//char	OutFile[]= "ndist309G-mt.txt";
char	OutFile[]= "127-G46s.c.txt";

int main(int argc,char *argv[] ){

	int		i,j,k;
	long	in0[64], in1[64];
	double	dn[64];

	double	dMax;
	double	dMin;

	const	int		jloop=500; //00;
	const	int		iloop=100000000;
	int		kloop=20;

	if( argc== 2 ){
		kloop= atoi( argv[1] );
		if( kloop<1 ) kloop=1;
	}

	FILE	*out;

	out = fopen( OutFile , "at");
	fclose( out );

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		for( i=0;i<64;i++) dn[i]=0.0;
		for( i=0;i<64;i++) in0[i]=0;
		for( i=0;i<64;i++) in1[i]=0;

		dMax= dMin= 0.0;
		p1= 0; //p2= p3= p4= 0;

		MT_rr_init(&p1);

		st_t= (double)clock();

		for( j=0;j<jloop;j++ ){
			//			printf("%d  ",j);
			for( i=0;i<iloop;i++ ){
				double	dTemp;
				int		iTemp;

				if( ( dTemp= MT_nsdF() ) > dMax )	dMax= dTemp;
				else if ( dTemp < dMin )			dMin= dTemp;

				if( ++in0[ iTemp= (int)( dTemp + 20.0 ) ] >= 100000000 ){
					in1[ iTemp ]++;
					in0[ iTemp ]= 0;
				}
			}
		}

		for( i=0;i<64;i++ ) dn[i]= (double)in0[i] + (double)in1[i]*1.0e8;

		ed_t= (double)clock();

		if (( out = fopen( OutFile , "at")) == NULL){
			printf(" I can not open an input file.\n");
			exit(0);
		}

		printf("\n%x\n",p1);
		fprintf(out,"\n%x\n",p1);

		printf("\n %6.2f sec", (ed_t-st_t)/(double)CLK_TCK );
		fprintf(out,"\n %6.2f sec", (ed_t-st_t)/(double)CLK_TCK );

		//		printf("\n jloop=,\tiloop=\n");
		fprintf(out,"\n jloop=,\tiloop=\n");

		//		printf("\n%d",jloop );
		//		printf("\n%d",iloop );
		fprintf(out,"\n%d",jloop );
		fprintf(out,"\n%d",iloop );

		for( i=9;i<31;i++){
			printf("%15.0lf\n",dn[i]);
			fprintf(out,"%15.0lf\n",dn[i]);
		}

		printf("%12.8f\n%12.8f\n",dMax, dMin);
		fprintf( out, "%12.8f\n%12.8f\n",dMax, dMin);

		fflush( out );
		fclose( out );

	} // for( k )

	return( 0 );

}  /* end of main */

