/************************************************
Kz̕]
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
time_t		st_t,ed_t;

#include "127-G46s.h"

unsigned	int	p1; //,p2,p3,p4;

int main(int argc,char **argv ){

	int		i,j,k;

	const	int		jloop=500;
	const	int		iloop=1000000;
	const	int		kloop=1;

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		p1= 10;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_nsdF\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					sum  +=  dTemp = MT_nsdF();
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		p1= 10;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					sum  +=  dTemp = MT_nsd();
					sum2 += dTemp * dTemp -1.0;
					//					printf("%f\n",dTemp);
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		p1= 10;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_nsd_52()\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp= 0.0;
					sum  +=  dTemp = MT_nsd_52();
					sum2 += dTemp * dTemp -1.0;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", dAve= sum/(double)jloop/(double)iloop );
				printf("Sigma=   \t%15.12lf\n", sqrt((sum2 + (1.0 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

	} // for( k )

	return(0);

}  /* end of main */

