/************************************************
Kz̕]
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
time_t		st_t,ed_t;

#include "127-G46s.h"

unsigned	int	p1; //,p2,p3,p4;

int main(int argc,char **argv ){

	int		i,j,k;

	const	int		jloop=20; //00; //00;
	const	int		iloop=1000000;
	const	int		kloop=1;

	//	const	double	sq12= 1.0/sqrt(12.0);
	const	double	sq02= 1.0/sqrt( 2.0);

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test: MT_nsd - MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					double	d1, d2;
					d1= MT_nsd();
					d2= MT_nsd();
					sum  +=  dTemp = ( d1 - d2 )*sq02;
					sum2 += dTemp * dTemp - 1.0;
				}
			}
			{
				double dAve;
				double	dn;
				dn= (double)jloop*(double)iloop;
				printf("Average= \t%15.12lf\n", dAve= sum/dn  );
				printf("Sigma=   \t%15.12lf\n", sqrt( (sum2 + dn - dn*dAve*dAve )/(dn-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------
		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test: MT_nsd - MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					double	d1, d2;
					d1= MT_nsd();
					MT_nsd();
					d2= MT_nsd();
					sum  +=  dTemp = ( d1 - d2 )*sq02;
					sum2 += dTemp * dTemp - 1.0;
				}
			}
			{
				double dAve;
				double	dn;
				dn= (double)jloop*(double)iloop;
				printf("Average= \t%15.12lf\n", dAve= sum/dn  );
				printf("Sigma=   \t%15.12lf\n", sqrt( (sum2 + dn - dn*dAve*dAve )/(dn-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------
		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test: MT_nsd - MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					double	d1, d2;
					d1= MT_nsd();
					MT_nsd();
					MT_nsd();
					d2= MT_nsd();
					sum  +=  dTemp = ( d1 - d2 )*sq02;
					sum2 += dTemp * dTemp - 1.0;
				}
			}
			{
				double dAve;
				double	dn;
				dn= (double)jloop*(double)iloop;
				printf("Average= \t%15.12lf\n", dAve= sum/dn  );
				printf("Sigma=   \t%15.12lf\n", sqrt( (sum2 + dn - dn*dAve*dAve )/(dn-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------
		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test: MT_nsd - MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					double	d1, d2;
					d1= MT_nsd();
					MT_nsd();
					MT_nsd();
					MT_nsd();
					d2= MT_nsd();
					sum  +=  dTemp = ( d1 - d2 )*sq02;
					sum2 += dTemp * dTemp - 1.0;
				}
			}
			{
				double dAve;
				double	dn;
				dn= (double)jloop*(double)iloop;
				printf("Average= \t%15.12lf\n", dAve= sum/dn  );
				printf("Sigma=   \t%15.12lf\n", sqrt( (sum2 + dn - dn*dAve*dAve )/(dn-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------
		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test: MT_nsd - MT_nsd\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					double	d1, d2;
					d1= MT_nsd();
					MT_nsd();
					MT_nsd();
					MT_nsd();
					MT_nsd();
					d2= MT_nsd();
					sum  +=  dTemp = ( d1 - d2 )*sq02;
					sum2 += dTemp * dTemp - 1.0;
				}
			}
			{
				double dAve;
				double	dn;
				dn= (double)jloop*(double)iloop;
				printf("Average= \t%15.12lf\n", dAve= sum/dn  );
				printf("Sigma=   \t%15.12lf\n", sqrt( (sum2 + dn - dn*dAve*dAve )/(dn-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

	} // for( k )

	return( 0 );

}  /* end of main */

