#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "127-G46s.h"

int		tm1, tm2; //,tm3;

//inline unsigned int	MT_rand32( void );
//void			MT_rr_init( unsigned long * );

/******************************/

#define  jLoop  60   // 12̔{
#define  iLoop  100000000

int main( )
{
	int	i;
	int	j;
	unsigned int	ret;
	unsigned int	p1;
	double			dd;

	//	()
	p1= 100;
	MT_rr_init(&p1);

	printf("%x\n",p1 );

	tm2= clock();
	while( tm2==(tm1=clock()) );

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			ret = MT_rand32();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	//		ret= MT_rand32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-----------------------------------------------------------------

	p1= 100;
	MT_rr_init(&p1);

	tm2= clock();
	while( tm2==(tm1=clock()) );

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			ret = MT_rand32();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	//		ret= MT_rand32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-------------------------------------

	p1= 100;
	MT_rr_init(&p1);

	tm2= clock();
	while( tm2==(tm1=clock()) );

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			ret = MT_rand32() + MT_rand32() + MT_rand32() + MT_rand32();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	//-------------------------------------
	p1= 100;
	MT_rr_init(&p1);

	tm2= clock();
	while( tm2==(tm1=clock()) );

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			ret = MT_rand32() + MT_rand32() + MT_rand32() + MT_rand32();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	return( 0 );
}
