#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "mt19937ar.c"
unsigned long	init[4], length;

int		tm1, tm2,tm3;

/******************************/

#define  jLoop  10 // (1<<10) // 10
#define  iLoop  1000000 // (1<<28) // 28  // 268435456

int	main( int argc, char *argv[] )
{
	unsigned int	iMask= 0x1 ;
	int	k;
	/*
	{
		if( argc==2 ){
			k=  atoi( argv[1] );
			if( k<0 || k>=32 ){
				printf("program.exe xx ( 0 to 31 )\n");
				return( -1 );
			}
		}
		else{
			printf("program.exe xx ( 0 to 31 )\n");
			return( -1 );
		}
	}
	*/

	unsigned int		p1,p2,p3,p4;
	p1= p2= p3= p4= 0;

	//	()
	{
		init[0]= p1 += time( NULL );
		init[1]= p2 += clock();
		init_by_array(init, length);

		init[0]= p1+=  genrand_int32();
		init[1]= p2+=  genrand_int32();
		init[2]= p3+=  genrand_int32();
		init[3]= p4+=  genrand_int32();
		init_by_array(init, length);
	}

	for( k=0;k<32;k++ ){
		iMask= 0x1 ;
		iMask<<=k;

		printf("%10x\t",iMask);

		int	i;
		int	j;
		unsigned int  mk;
		//	int	ii;

		unsigned int		iData0[32][32]; //, iData00[64];
		unsigned int		iData1[32][32]; //, iData11[64];

		unsigned int		iRand[32];

		for( i=0;i<32;i++ ){
			for( j=0;j<32;j++ ){
				iData0[i][j]= 0;
				iData1[i][j]= 0;
			}
		}

		tm2= clock();
		while( tm2==(tm1=clock()) );

		//	()
		{
			init[0]= p1 += genrand_int32() + clock();
			init[1]= p2 += genrand_int32() + clock();
			init[2]= p3 += genrand_int32() + clock();
			init[3]= p4 += genrand_int32() + clock();
			init_by_array(init, length);
		}

		for( j=jLoop;j>0;j--){
			//		printf("j=%4d\n", j   );
			for (i = iLoop; i >0 ; i--) {
				//			printf("i=%4d\n", i   );
				int	ii, jj;

				for( ii=0;ii<32;ii++ ) iRand[ii]= genrand_int32();
				mk= iRand[0] & iMask;

				//	printf("mk= %8x\n",mk);

				if( mk==0 ){
					for( ii=0;ii<32;ii++ ){
						unsigned int	id= 1;
						for( jj=0;jj<32;jj++ ){
							if( !( iRand[ii]&id ) ){
								iData0[ii][jj]++;
							}
							id = id<<1;
						}
					}
				}else{
					for( ii=0;ii<32;ii++ ){
						unsigned int	id= 1;
						for( jj=0;jj<32;jj++ ){
							if( ( iRand[ii]&id ) ){
								iData1[ii][jj]++;
							}
							id = id<<1;
						}
					}
				}

			}
		}
		/*
		{
			int	i1,i2;
			for( i1=0;i1<32;i1++ ) printf("%d, ", iData1[0][i1] );
			printf("\n");

			for( i1=0;i1<32;i1++ ) printf("%d, ", iData0[0][i1] );
			printf("\n");

		}
		*/
		{
			int	ii, jj;
			double	sum, dExp;

			sum= 0.0;

			dExp= iData1[0][k]/2.0;
			for( ii=0;ii<32;ii++){
				for( jj=0;jj<32;jj++ ){
					if( (ii==0) && (jj==k) ) continue;
					double	dd;
					dd= iData1[ii][jj]-dExp;
					sum += dd*dd/dExp;
				}
			}

			dExp= iData0[0][k]/2.0;
			for( ii=0;ii<32;ii++){
				for( jj=0;jj<32;jj++ ){
					if( (ii==0) && (jj==k) ) continue;
					double	dd;
					dd= iData0[ii][jj]-dExp;
					sum += dd*dd/dExp;
				}
			}

			tm2= clock();

			{
				double dd;
				dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

				printf("Sum= \t%8.3f\n", sum );
			}
		}

	} // k

	//-----------------------------------------------------------------
	return( 0 );
}
