/*

*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "mt19937ar.c"

#define		size	256

unsigned long	init[4], length;

int main(void)
{
	int i,j,k;
	int  box[size][size];

	unsigned int		p1,p2,p3,p4;
	p1= p2= p3= p4= 0;

	int		ic[20];

	double	t0,t1,t2;

	t0= (double)clock();

	//	()
	{
		init[0]= p1 += time( NULL );
		init[1]= p2 += clock();
		init_by_array(init, length);

		init[0]= p1+=  genrand_int32();
		init[1]= p2+=  genrand_int32();
		init[2]= p3+=  genrand_int32();
		init[3]= p4+=  genrand_int32();
		init_by_array(init, length);
	}

	for( i=0;i<20;i++ ) ic[i]= 0;
	int	in= 0;
	double	sum;

	double	sum2= 0.0;

	t1= (double)clock();

	for( k=0;k<250;k++ ){

		//	()
		{
			init[0]= p1 += genrand_int32() + clock();
			init[1]= p2 += genrand_int32() + time( NULL );
			init[2]= p3 += genrand_int32() + clock();
			init[3]= p4 += genrand_int32() + time( NULL );
			init_by_array(init, length);
		}

		sum2= 0.0;
		in = 0;

		for( j=1000 ;j>0;j--){
			{
				int	ii, jj;
				for( ii=0;ii<size;ii++ ){
					for( jj=0;jj<size;jj++ ){
						box[ii][jj]=0;
					}
				}
			}

#define  loop size*size*100

			for (i = loop ; i > 0 ; i--){
				unsigned int  irand;

				irand= genrand_int32();

				box[ (irand      & 0xff)][ (irand>>24) & 0xff ]++;
			}

			{
				double	dd;
				int		ii,jj;

				sum= 0.0;

				for( ii=0;ii<size;ii++ ){
					for( jj=0;jj<size;jj++ ){
						dd= (double)( box[ii][jj] - (loop/(size*size) ) );
						sum += dd*dd;
					}
				}

				sum /= (double)(loop/(size*size) );

			}

			in += 1;
			sum2 += sum;

		} // for( j )

		t2= (double)clock();

		printf(" n= %5d Average= %f\t", in, sum2/(double)in );
		printf("\t%x,%x,%x,%x\n",p1,p2,p3,p4);

	}	// k

	return( 0 );
}
