/************************************************
Kz̕]

308 ƌ݊
308  ́Adouble						27.42 sec	274.45 sec
309  ́Along x2 Ōオl	26.98 sec	268.63 sec  2.12%

************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
time_t		st_t,ed_t;

#include "127-G46s.h"

unsigned	int	p1; //,p2,p3,p4;

int	main(int argc,char **argv ){

	int		i,j,k;

	const	int		jloop=1000; //00; //00;
	const	int		iloop=1000000;
	const	int		kloop=1;

	const	double	sq12= 1.0/sqrt(12.0);

	for( k=kloop;k>0;k-- ){
		printf("\n*** k=%d ***\n",k);

		p1= 0;
		MT_rr_init(&p1);

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drand\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					dTemp = MT_drand();
					sum  +=  dTemp -0.5;
					sum2 += dTemp * dTemp -sq12;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", (1.0/0.5)*(dAve= 0.5 + sum/(double)jloop/(double)iloop)  );
				printf("Sigma=   \t%15.12lf\n", (1.0/sq12)*sqrt((sum2 + (sq12 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drandp\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					dTemp = MT_drandp();
					sum += dTemp - 0.5;
					sum2 += dTemp * dTemp -sq12;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", (1.0/0.5)*(dAve= 0.5 + sum/(double)jloop/(double)iloop)  );
				printf("Sigma=   \t%15.12lf\n", (1.0/sq12)*sqrt((sum2 + (sq12 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drand_52\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					dTemp = MT_drand_52();
					sum += dTemp - 0.5;
					sum2 += dTemp * dTemp -sq12;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", (1.0/0.5)*(dAve= 0.5 + sum/(double)jloop/(double)iloop)  );
				printf("Sigma=   \t%15.12lf\n", (1.0/sq12)*sqrt((sum2 + (sq12 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

		//---------------

		st_t= clock();
		{
			double		sum, sum2;
			sum= sum2= 0.0;
			printf("Test MT_drandp_52\n");
			for( j=0;j<jloop;j++ ){
				for( i=0;i<iloop;i++ ){
					double	dTemp;
					dTemp = MT_drandp_52();
					sum += dTemp - 0.5;
					sum2 += dTemp * dTemp -sq12;
				}
			}
			{
				double dAve;
				printf("Average= \t%15.12lf\n", (1.0/0.5)*(dAve= 0.5 + sum/(double)jloop/(double)iloop)  );
				printf("Sigma=   \t%15.12lf\n", (1.0/sq12)*sqrt((sum2 + (sq12 - dAve*dAve )*(double)jloop*(double)iloop)/((double)jloop*(double)iloop-1.0) ) );
			}
		}
		ed_t= clock();
		printf(" %6.2f sec\n", (double)(ed_t-st_t)/(double)CLOCKS_PER_SEC );

	} // for( k )
	return(0);
}  /* end of main */

